diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/visualizer/model/pyviz.h ns-3.44/src/visualizer/model/pyviz.h
--- ns-3.43/src/visualizer/model/pyviz.h	2024-10-09 16:41:10.104656700 -0700
+++ ns-3.44/src/visualizer/model/pyviz.h	2025-03-09 16:55:49.755372500 -0700
@@ -27,10 +27,10 @@
 {
 
 /**
- * \ingroup visualizer
+ * @ingroup visualizer
  *
- * \brief helper class to be used by the visualizer
- * \internal
+ * @brief helper class to be used by the visualizer
+ * @internal
  *
  * This class is not meant to be used by simulations.  It is only
  * meant to be used by the visualizer tool (PyViz).  The only reason
@@ -45,40 +45,40 @@
 
     /**
      * Register drop trace path function
-     * \param tracePath the path to trace
+     * @param tracePath the path to trace
      */
     void RegisterDropTracePath(const std::string& tracePath);
 
     /**
      * Register CSMA like device function
-     * \param deviceTypeName the device type name
+     * @param deviceTypeName the device type name
      */
     void RegisterCsmaLikeDevice(const std::string& deviceTypeName);
     /**
      * Register WIFI like device function
-     * \param deviceTypeName the device type name
+     * @param deviceTypeName the device type name
      */
     void RegisterWifiLikeDevice(const std::string& deviceTypeName);
     /**
      * Register point to point like device function
-     * \param deviceTypeName the device type name
+     * @param deviceTypeName the device type name
      */
     void RegisterPointToPointLikeDevice(const std::string& deviceTypeName);
 
     /**
      * Run simulation until a given (simulated, absolute) time is reached
-     * \param time the run time
+     * @param time the run time
      */
     void SimulatorRunUntil(Time time);
 
     /**
      * Pause function
-     * \param message the pause message
+     * @param message the pause message
      */
     static void Pause(const std::string& message);
     /**
      * Get pause message function
-     * \returns the pause message
+     * @returns the pause message
      */
     std::vector<std::string> GetPauseMessages() const;
 
@@ -95,7 +95,7 @@
         TransmissionSampleList; ///< TransmissionSampleList typedef
     /**
      * Get transmission samples
-     * \returns the transmission sample list
+     * @returns the transmission sample list
      */
     TransmissionSampleList GetTransmissionSamples() const;
 
@@ -109,7 +109,7 @@
     typedef std::vector<PacketDropSample> PacketDropSampleList; ///< PacketDropSampleList typedef
     /**
      * Get packet drop samples
-     * \returns the packet drop sample list
+     * @returns the packet drop sample list
      */
     PacketDropSampleList GetPacketDropSamples() const;
 
@@ -143,14 +143,14 @@
 
     /**
      * Get last packets function
-     * \param nodeId the node ID
-     * \returns the last packets
+     * @param nodeId the node ID
+     * @returns the last packets
      */
     LastPacketsSample GetLastPackets(uint32_t nodeId) const;
 
     /**
      * Set nodes of interest function
-     * \param nodes the collection of nodes
+     * @param nodes the collection of nodes
      */
     void SetNodesOfInterest(std::set<uint32_t> nodes);
 
@@ -181,7 +181,7 @@
 
     /**
      * Get node statistics
-     * \returns the node statistics
+     * @returns the node statistics
      */
     std::vector<NodeStatistics> GetNodesStatistics() const;
 
@@ -205,25 +205,25 @@
 
     /**
      * Set packet capture options function
-     * \param nodeId the node ID
-     * \param options the capture options
+     * @param nodeId the node ID
+     * @param options the capture options
      */
     void SetPacketCaptureOptions(uint32_t nodeId, PacketCaptureOptions options);
 
     // Yes, I know, this is just a utility function, not really related to the class in any way.
     /**
      * Utility function - clips a line to a bounding box.
-     * \param [in] boundsX1 Bounding box, minimum X coord
-     * \param [in] boundsY1 Bounding box, minimum Y coord
-     * \param [in] boundsX2 Bounding box, maximum X coord
-     * \param [in] boundsY2 Bounding box, maximum Y coord
-     * \param [in,out] lineX1 Line, minimum X coord (any on input, clipped to the bounding box
+     * @param [in] boundsX1 Bounding box, minimum X coord
+     * @param [in] boundsY1 Bounding box, minimum Y coord
+     * @param [in] boundsX2 Bounding box, maximum X coord
+     * @param [in] boundsY2 Bounding box, maximum Y coord
+     * @param [in,out] lineX1 Line, minimum X coord (any on input, clipped to the bounding box
      * on output)
-     * \param [in,out] lineY1 Line, minimum Y coord (any on input, clipped to the bounding box
+     * @param [in,out] lineY1 Line, minimum Y coord (any on input, clipped to the bounding box
      * on output)
-     * \param [in,out] lineX2 Line, maximum X coord (any on input, clipped to the bounding box
+     * @param [in,out] lineX2 Line, maximum X coord (any on input, clipped to the bounding box
      * on output)
-     * \param [in,out] lineY2 Line, maximum Y coord (any on input, clipped to the bounding box
+     * @param [in,out] lineY2 Line, maximum Y coord (any on input, clipped to the bounding box
      * on output)
      */
     // -#- @lineX1(direction=inout); @lineY1(direction=inout); @lineX2(direction=inout);
@@ -241,16 +241,16 @@
   private:
     /**
      * Get packet capture options function
-     * \param nodeId the node ID
-     * \param outOptions the packet capture options
-     * \returns true if successful
+     * @param nodeId the node ID
+     * @param outOptions the packet capture options
+     * @returns true if successful
      */
     bool GetPacketCaptureOptions(uint32_t nodeId, const PacketCaptureOptions** outOptions) const;
     /**
      * Filter packet function
-     * \param packet the packet
-     * \param options the capture options
-     * \returns true if successful
+     * @param packet the packet
+     * @param options the capture options
+     * @returns true if successful
      */
     static bool FilterPacket(Ptr<const Packet> packet, const PacketCaptureOptions& options);
 
@@ -270,15 +270,15 @@
         /**
          * Less than operator
          *
-         * \param other object to compare
-         * \return true if less than
+         * @param other object to compare
+         * @return true if less than
          */
         bool operator<(const TransmissionSampleKey& other) const;
         /**
          * Equality operator
          *
-         * \param other object to compare
-         * \return true if equal
+         * @param other object to compare
+         * @return true if equal
          */
         bool operator==(const TransmissionSampleKey& other) const;
         Ptr<Node> transmitter; ///< transmitter
@@ -308,18 +308,18 @@
     // Trace callbacks
     /**
      * Network transmit common trace callback function
-     * \param context the context
-     * \param packet the packet
-     * \param destination the destination MAC address
+     * @param context the context
+     * @param packet the packet
+     * @param destination the destination MAC address
      */
     void TraceNetDevTxCommon(const std::string& context,
                              Ptr<const Packet> packet,
                              const Mac48Address& destination);
     /**
      * Network receive common trace callback function
-     * \param context the context
-     * \param packet the packet
-     * \param source the source MAC address
+     * @param context the context
+     * @param packet the packet
+     * @param source the source MAC address
      */
     void TraceNetDevRxCommon(const std::string& context,
                              Ptr<const Packet> packet,
@@ -327,31 +327,31 @@
 
     /**
      * Wi-Fi transmit trace callback function
-     * \param context the context
-     * \param packet the packet
+     * @param context the context
+     * @param packet the packet
      */
     void TraceNetDevTxWifi(std::string context, Ptr<const Packet> packet);
     /**
      * Wi-Fi receive trace callback function
-     * \param context the context
-     * \param packet the packet
+     * @param context the context
+     * @param packet the packet
      */
     void TraceNetDevRxWifi(std::string context, Ptr<const Packet> packet);
 
     /**
      * Queue drop trace callback function
-     * \param context the context
-     * \param packet the packet
+     * @param context the context
+     * @param packet the packet
      */
     void TraceDevQueueDrop(std::string context, Ptr<const Packet> packet);
     /**
      * Ipv4 drop trace callback function
-     * \param context the context
-     * \param hdr the header
-     * \param packet the packet
-     * \param reason the drop reason
-     * \param dummy_ipv4 the dummy Ipv4
-     * \param interface the interface
+     * @param context the context
+     * @param hdr the header
+     * @param packet the packet
+     * @param reason the drop reason
+     * @param dummy_ipv4 the dummy Ipv4
+     * @param interface the interface
      */
     void TraceIpv4Drop(std::string context,
                        const ns3::Ipv4Header& hdr,
@@ -362,50 +362,50 @@
 
     /**
      * CSMA transmit trace callback function
-     * \param context the context
-     * \param packet the packet
+     * @param context the context
+     * @param packet the packet
      */
     void TraceNetDevTxCsma(std::string context, Ptr<const Packet> packet);
     /**
      * CSMA receive trace callback function
-     * \param context the context
-     * \param packet the packet
+     * @param context the context
+     * @param packet the packet
      */
     void TraceNetDevRxCsma(std::string context, Ptr<const Packet> packet);
     /**
      * CSMA promiscuous receive function
-     * \param context the context
-     * \param packet the packet
+     * @param context the context
+     * @param packet the packet
      */
     void TraceNetDevPromiscRxCsma(std::string context, Ptr<const Packet> packet);
 
     /**
      * Point to point transmit trace callback function
-     * \param context the context
-     * \param packet the packet
+     * @param context the context
+     * @param packet the packet
      */
     void TraceNetDevTxPointToPoint(std::string context, Ptr<const Packet> packet);
     /**
      * Point to point receive trace callback function
-     * \param context the context
-     * \param packet the packet
+     * @param context the context
+     * @param packet the packet
      */
     void TraceNetDevRxPointToPoint(std::string context, Ptr<const Packet> packet);
 
     /**
      * WiMax transmit trace callback function
-     * \param context the context
-     * \param packet the packet
-     * \param destination the destination MAC address
+     * @param context the context
+     * @param packet the packet
+     * @param destination the destination MAC address
      */
     void TraceNetDevTxWimax(std::string context,
                             Ptr<const Packet> packet,
                             const Mac48Address& destination);
     /**
      * WiMax transmit trace callback function
-     * \param context the context
-     * \param packet the packet
-     * \param source the source MAC address
+     * @param context the context
+     * @param packet the packet
+     * @param source the source MAC address
      */
     void TraceNetDevRxWimax(std::string context,
                             Ptr<const Packet> packet,
@@ -413,18 +413,18 @@
 
     /**
      * LTE transmit trace callback function
-     * \param context the context
-     * \param packet the packet
-     * \param destination the destination MAC address
+     * @param context the context
+     * @param packet the packet
+     * @param destination the destination MAC address
      */
     void TraceNetDevTxLte(std::string context,
                           Ptr<const Packet> packet,
                           const Mac48Address& destination);
     /**
      * LTE receive trace callback function
-     * \param context the context
-     * \param packet the packet
-     * \param source the MAC address of the source
+     * @param context the context
+     * @param packet the packet
+     * @param source the MAC address of the source
      */
     void TraceNetDevRxLte(std::string context,
                           Ptr<const Packet> packet,
@@ -432,15 +432,15 @@
 
     /**
      * Find net device statistics function
-     * \param node the node
-     * \param interface the interface number
-     * \returns the device statistics
+     * @param node the node
+     * @param interface the interface number
+     * @returns the device statistics
      */
     inline NetDeviceStatistics& FindNetDeviceStatistics(int node, int interface);
 
     /**
      * Do pause function
-     * \param message the pause message
+     * @param message the pause message
      */
     void DoPause(const std::string& message);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/visualizer/model/visual-simulator-impl.cc ns-3.44/src/visualizer/model/visual-simulator-impl.cc
--- ns-3.43/src/visualizer/model/visual-simulator-impl.cc	2024-10-09 16:41:10.104656700 -0700
+++ ns-3.44/src/visualizer/model/visual-simulator-impl.cc	2025-03-09 16:55:49.755372500 -0700
@@ -24,7 +24,7 @@
 {
 /**
  * Get an object factory configured to the default simulator implementation
- * \return an object factory.
+ * @return an object factory.
  */
 ObjectFactory
 GetDefaultSimulatorImplFactory()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/visualizer/model/visual-simulator-impl.h ns-3.44/src/visualizer/model/visual-simulator-impl.h
--- ns-3.43/src/visualizer/model/visual-simulator-impl.h	2024-10-09 16:41:10.104656700 -0700
+++ ns-3.44/src/visualizer/model/visual-simulator-impl.h	2025-03-09 16:55:49.755372500 -0700
@@ -15,15 +15,15 @@
 {
 
 /**
- * \defgroup  visualizer Visualizer
+ * @defgroup  visualizer Visualizer
  *
  */
 
 /**
- * \ingroup visualizer
- * \ingroup simulator
+ * @ingroup visualizer
+ * @ingroup simulator
  *
- * \brief A replacement simulator that starts the visualizer
+ * @brief A replacement simulator that starts the visualizer
  *
  * To use this class, run any ns-3 simulation with the command-line
  * argument --SimulatorImplementationType=ns3::VisualSimulatorImpl.
@@ -33,8 +33,8 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/visualizer/visualizer/ipython_view.py ns-3.44/src/visualizer/visualizer/ipython_view.py
--- ns-3.43/src/visualizer/visualizer/ipython_view.py	2024-10-09 16:41:10.104656700 -0700
+++ ns-3.44/src/visualizer/visualizer/ipython_view.py	2025-03-09 16:55:49.755372500 -0700
@@ -16,6 +16,7 @@
 
 import gi
 
+gi.require_version("Gdk", "3.0")
 gi.require_version("Gtk", "3.0")
 import os
 import re
@@ -24,7 +25,7 @@
 from io import StringIO
 
 from gi.repository import Gdk, GLib, Gtk, Pango
-from pkg_resources import parse_version
+from packaging.version import Version
 
 ## Try to import IPython
 try:
@@ -138,7 +139,7 @@
         sys.excepthook = excepthook
         self.iter_more = 0
         self.history_level = 0
-        self.complete_sep = re.compile("[\s\{\}\[\]\(\)]")
+        self.complete_sep = re.compile(r"[\s\{\}\[\]\(\)]")
         self.updateNamespace({"exit": lambda: None})
         self.updateNamespace({"quit": lambda: None})
         # Workaround for updating namespace with sys.modules
@@ -148,7 +149,7 @@
         # Avoid using input splitter when not really needed.
         # Perhaps it could work even before 5.8.0
         # But it definitely does not work any more with >= 7.0.0
-        self.no_input_splitter = parse_version(IPython.release.version) >= parse_version("5.8.0")
+        self.no_input_splitter = Version(IPython.release.version) >= Version("5.8.0")
         self.lines = []
         self.indent_spaces = ""
 
@@ -418,7 +419,7 @@
         Initialize console view.
         """
         Gtk.TextView.__init__(self)
-        self.modify_font(Pango.FontDescription("Mono"))
+        self.set_monospace(True)
         self.set_cursor_visible(True)
         self.text_buffer = self.get_buffer()
         self.mark = self.text_buffer.create_mark(
@@ -433,7 +434,7 @@
             )
         self.text_buffer.create_tag("0")
         self.text_buffer.create_tag("notouch", editable=False)
-        self.color_pat = re.compile("\x01?\x1b\[(.*?)m\x02?")
+        self.color_pat = re.compile(r"\x01?\x1b\[(.*?)m\x02?")
         self.line_start = self.text_buffer.create_mark(
             "line_start", self.text_buffer.get_end_iter(), True
         )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/visualizer/visualizer/ipython_view.py.license ns-3.44/src/visualizer/visualizer/ipython_view.py.license
--- ns-3.43/src/visualizer/visualizer/ipython_view.py.license	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/src/visualizer/visualizer/ipython_view.py.license	2025-03-09 16:55:49.755372500 -0700
@@ -0,0 +1,2 @@
+Copyright (c) 2007 IBM Corporation
+SPDX-License-Identifier: BSD-3-Clause
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/CMakeLists.txt ns-3.44/src/wifi/CMakeLists.txt
--- ns-3.43/src/wifi/CMakeLists.txt	2024-10-09 16:41:10.108656600 -0700
+++ ns-3.44/src/wifi/CMakeLists.txt	2025-03-09 16:55:49.755372500 -0700
@@ -8,11 +8,13 @@
 set(source_files
     helper/athstats-helper.cc
     helper/spectrum-wifi-helper.cc
+    helper/wifi-co-trace-helper.cc
     helper/wifi-helper.cc
     helper/wifi-mac-helper.cc
     helper/wifi-radio-energy-model-helper.cc
     helper/yans-wifi-helper.cc
     helper/wifi-phy-rx-trace-helper.cc
+    helper/wifi-tx-stats-helper.cc
     model/addba-extension.cc
     model/adhoc-wifi-mac.cc
     model/ampdu-subframe-header.cc
@@ -30,6 +32,9 @@
     model/eht/advanced-ap-emlsr-manager.cc
     model/eht/advanced-emlsr-manager.cc
     model/eht/ap-emlsr-manager.cc
+    model/eht/advanced-ap-emlsr-manager.cc
+    model/eht/common-info-basic-mle.cc
+    model/eht/common-info-probe-req-mle.cc
     model/eht/default-ap-emlsr-manager.cc
     model/eht/default-emlsr-manager.cc
     model/eht/eht-capabilities.cc
@@ -46,6 +51,8 @@
     model/fcfs-wifi-queue-scheduler.cc
     model/frame-capture-model.cc
     model/frame-exchange-manager.cc
+    model/gcr-group-address.cc
+    model/gcr-manager.cc
     model/he/constant-obss-pd-algorithm.cc
     model/he/he-6ghz-band-capabilities.cc
     model/he/he-capabilities.cc
@@ -131,6 +138,7 @@
     model/wifi-bandwidth-filter.cc
     model/wifi-default-ack-manager.cc
     model/wifi-default-assoc-manager.cc
+    model/wifi-default-gcr-manager.cc
     model/wifi-default-protection-manager.cc
     model/wifi-information-element.cc
     model/wifi-mac-header.cc
@@ -171,11 +179,13 @@
 set(header_files
     helper/athstats-helper.h
     helper/spectrum-wifi-helper.h
+    helper/wifi-co-trace-helper.h
     helper/wifi-helper.h
     helper/wifi-mac-helper.h
     helper/wifi-radio-energy-model-helper.h
     helper/yans-wifi-helper.h
     helper/wifi-phy-rx-trace-helper.h
+    helper/wifi-tx-stats-helper.h
     model/addba-extension.h
     model/adhoc-wifi-mac.h
     model/ampdu-subframe-header.h
@@ -193,6 +203,8 @@
     model/eht/advanced-ap-emlsr-manager.h
     model/eht/advanced-emlsr-manager.h
     model/eht/ap-emlsr-manager.h
+    model/eht/common-info-basic-mle.h
+    model/eht/common-info-probe-req-mle.h
     model/eht/default-ap-emlsr-manager.h
     model/eht/default-emlsr-manager.h
     model/eht/eht-capabilities.h
@@ -209,6 +221,8 @@
     model/fcfs-wifi-queue-scheduler.h
     model/frame-capture-model.h
     model/frame-exchange-manager.h
+    model/gcr-group-address.h
+    model/gcr-manager.h
     model/he/constant-obss-pd-algorithm.h
     model/he/he-6ghz-band-capabilities.h
     model/he/he-capabilities.h
@@ -294,6 +308,7 @@
     model/wifi-bandwidth-filter.h
     model/wifi-default-ack-manager.h
     model/wifi-default-assoc-manager.h
+    model/wifi-default-gcr-manager.h
     model/wifi-default-protection-manager.h
     model/wifi-information-element.h
     model/wifi-mac-header.h
@@ -357,11 +372,13 @@
     test/spectrum-wifi-phy-test.cc
     test/tx-duration-test.cc
     test/wifi-aggregation-test.cc
+    test/wifi-co-trace-helper-test.cc
     test/wifi-dynamic-bw-op-test.cc
     test/wifi-eht-info-elems-test.cc
     test/wifi-emlsr-test.cc
     test/wifi-error-rate-models-test.cc
     test/wifi-fils-frame-test.cc
+    test/wifi-gcr-test.cc
     test/wifi-he-info-elems-test.cc
     test/wifi-ie-fragment-test.cc
     test/wifi-mac-ofdma-test.cc
@@ -372,6 +389,8 @@
     test/wifi-phy-rx-trace-helper-test.cc
     test/wifi-phy-thresholds-test.cc
     test/wifi-primary-channels-test.cc
+    test/wifi-probe-exchange-test.cc
+    test/wifi-retransmit-test.cc
     test/wifi-ru-allocation-test.cc
     test/wifi-channel-switching-test.cc
     test/wifi-test.cc
@@ -381,4 +400,5 @@
     test/wifi-non-ht-dup-test.cc
     test/wifi-phy-mu-mimo-test.cc
     test/wifi-operating-channel-test.cc
+    test/wifi-tx-stats-helper-test.cc
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/doc/Makefile ns-3.44/src/wifi/doc/Makefile
--- ns-3.43/src/wifi/doc/Makefile	2024-10-09 16:41:10.108656600 -0700
+++ ns-3.44/src/wifi/doc/Makefile	2025-03-09 16:55:49.755372500 -0700
@@ -28,6 +28,7 @@
         $(FIGURES)/assoc-manager.eps \
         $(FIGURES)/clear-channel.eps \
         $(FIGURES)/emlsr-dl-txop.eps \
+        $(FIGURES)/emlsr-txop-ended-trace.eps \
         $(FIGURES)/emlsr-ul-txop.eps \
         $(FIGURES)/nist-frame-success-rate.eps \
         $(FIGURES)/nist-frame-success-rate-n.eps \
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/doc/source/figures/emlsr-ul-txop.eps ns-3.44/src/wifi/doc/source/figures/emlsr-ul-txop.eps
--- ns-3.43/src/wifi/doc/source/figures/emlsr-ul-txop.eps	2024-10-09 16:41:10.108656600 -0700
+++ ns-3.44/src/wifi/doc/source/figures/emlsr-ul-txop.eps	2025-03-09 16:55:49.767372600 -0700
@@ -1,7 +1,7 @@
 %!PS-Adobe-3.0 EPSF-3.0 
 %%BoundingBox: 0 0 1077 567
 %%Pages: 0
-%%Creator: LibreOffice 7.5
+%%Creator: LibreOffice 24.8
 %%Title: none
 %%CreationDate: none
 %%LanguageLevel: 2
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/examples/CMakeLists.txt ns-3.44/src/wifi/examples/CMakeLists.txt
--- ns-3.43/src/wifi/examples/CMakeLists.txt	2024-10-09 16:41:10.112656800 -0700
+++ ns-3.44/src/wifi/examples/CMakeLists.txt	2025-03-09 16:55:49.775372500 -0700
@@ -66,3 +66,13 @@
     ${libinternet}
     ${libmobility}
 )
+
+build_lib_example(
+  NAME wifi-co-trace-example
+  SOURCE_FILES wifi-co-trace-example.cc
+  LIBRARIES_TO_LINK
+    ${libwifi}
+    ${libinternet}
+    ${libmobility}
+    ${libapplications}
+)
